"use strict";
var helpers_1 = require("./helpers");
module.exports = function (babel) {
    var t = babel.types;
    return {
        name: 'babel-plugin-react-observer-displayname',
        visitor: {
            CallExpression: function (path) {
                if (!t.isIdentifier(path.node.callee) ||
                    path.node.callee.name !== 'observer' ||
                    path.node.arguments.length !== 1 ||
                    !t.isArrowFunctionExpression(path.node.arguments[0])) {
                    return;
                }
                var parentNode = path.parentPath.node;
                if (!t.isVariableDeclarator(parentNode) ||
                    !t.isIdentifier(parentNode.id)) {
                    return;
                }
                var componentName = parentNode.id.name;
                var nearestStatement = path.find(t.isStatement);
                nearestStatement.insertAfter(helpers_1.makeDisplayName(componentName, "observer(" + componentName + ")"));
            },
        },
    };
};
//# sourceMappingURL=plugin.js.map